{-# LANGUAGE OverloadedStrings #-}

module NLP.Romkan.Internal
       (
         romKanAList
       , romKanAList_H
       , kanRomAList
       , kanRomAList_H
       , kunreiToHepburnAList
       , hepburnToKunreiAList
       ) where

import Data.Text (Text)

romKanAList :: [(Text, Text)]
romKanAList =
  [
    ("bbya", "ッビャ")
   ,("bbyo", "ッビョ")
   ,("bbyu", "ッビュ")
   ,("ccha", "ッチャ")
   ,("cche", "ッチェ")
   ,("cchi", "ッチ")
   ,("ccho", "ッチョ")
   ,("cchu", "ッチュ")
   ,("ddya", "ッヂャ")
   ,("ddyo", "ッヂョ")
   ,("ddyu", "ッヂュ")
   ,("ggya", "ッギャ")
   ,("ggyo", "ッギョ")
   ,("ggyu", "ッギュ")
   ,("hhya", "ッヒャ")
   ,("hhyo", "ッヒョ")
   ,("hhyu", "ッヒュ")
   ,("kkya", "ッキャ")
   ,("kkyo", "ッキョ")
   ,("kkyu", "ッキュ")
   ,("ppya", "ッピャ")
   ,("ppyo", "ッピョ")
   ,("ppyu", "ッピュ")
   ,("rrya", "ッリャ")
   ,("rryo", "ッリョ")
   ,("rryu", "ッリュ")
   ,("ssha", "ッシャ")
   ,("sshe", "ッシェ")
   ,("sshi", "ッシ")
   ,("ssho", "ッショ")
   ,("sshu", "ッシュ")
   ,("ssya", "ッシャ")
   ,("ssye", "ッシェ")
   ,("ssyo", "ッショ")
   ,("ssyu", "ッシュ")
   ,("ttsu", "ッツ")
   ,("ttya", "ッチャ")
   ,("ttye", "ッチェ")
   ,("ttyo", "ッチョ")
   ,("ttyu", "ッチュ")
   ,("xtsu", "ッ")
   ,("zzya", "ッジャ")
   ,("zzyo", "ッジョ")
   ,("zzyu", "ッジュ")
   ,("bba", "ッバ")
   ,("bbe", "ッベ")
   ,("bbi", "ッビ")
   ,("bbo", "ッボ")
   ,("bbu", "ッブ")
   ,("bya", "ビャ")
   ,("byo", "ビョ")
   ,("byu", "ビュ")
   ,("cha", "チャ")
   ,("che", "チェ")
   ,("chi", "チ")
   ,("cho", "チョ")
   ,("chu", "チュ")
   ,("dda", "ッダ")
   ,("dde", "ッデ")
   ,("ddi", "ッヂ")
   ,("ddo", "ッド")
   ,("ddu", "ッドゥ")
   ,("dya", "ヂャ")
   ,("dyi", "ディ")
   ,("dyo", "ヂョ")
   ,("dyu", "ヂュ")
   ,("ffa", "ッファ")
   ,("ffe", "ッフェ")
   ,("ffi", "ッフィ")
   ,("ffo", "ッフォ")
   ,("ffu", "ッフュ")
   ,("gga", "ッガ")
   ,("gge", "ッゲ")
   ,("ggi", "ッギ")
   ,("ggo", "ッゴ")
   ,("ggu", "ッグ")
   ,("gya", "ギャ")
   ,("gyo", "ギョ")
   ,("gyu", "ギュ")
   ,("hha", "ッハ")
   ,("hhe", "ッヘ")
   ,("hhi", "ッヒ")
   ,("hho", "ッホ")
   ,("hhu", "ッフ")
   ,("hya", "ヒャ")
   ,("hyo", "ヒョ")
   ,("hyu", "ヒュ")
   ,("jja", "ッジャ")
   ,("jji", "ッジ")
   ,("jjo", "ッジョ")
   ,("jju", "ッジュ")
   ,("kka", "ッカ")
   ,("kke", "ッケ")
   ,("kki", "ッキ")
   ,("kko", "ッコ")
   ,("kku", "ック")
   ,("kya", "キャ")
   ,("kyo", "キョ")
   ,("kyu", "キュ")
   ,("mya", "ミャ")
   ,("myo", "ミョ")
   ,("myu", "ミュ")
   ,("nya", "ニャ")
   ,("nyo", "ニョ")
   ,("nyu", "ニュ")
   ,("ppa", "ッパ")
   ,("ppe", "ッペ")
   ,("ppi", "ッピ")
   ,("ppo", "ッポ")
   ,("ppu", "ップ")
   ,("pya", "ピャ")
   ,("pyo", "ピョ")
   ,("pyu", "ピュ")
   ,("rra", "ッラ")
   ,("rre", "ッレ")
   ,("rri", "ッリ")
   ,("rro", "ッロ")
   ,("rru", "ッル")
   ,("rya", "リャ")
   ,("ryo", "リョ")
   ,("ryu", "リュ")
   ,("sha", "シャ")
   ,("she", "シェ")
   ,("shi", "シ")
   ,("sho", "ショ")
   ,("shu", "シュ")
   ,("ssa", "ッサ")
   ,("sse", "ッセ")
   ,("ssi", "ッシ")
   ,("sso", "ッソ")
   ,("ssu", "ッス")
   ,("sya", "シャ")
   ,("sye", "シェ")
   ,("syo", "ショ")
   ,("syu", "シュ")
   ,("tsu", "ツ")
   ,("tta", "ッタ")
   ,("tte", "ッテ")
   ,("tti", "ッティ")
   ,("tto", "ット")
   ,("ttu", "ッツ")
   ,("tya", "チャ")
   ,("tye", "チェ")
   ,("tyo", "チョ")
   ,("tyu", "チュ")
   ,("vva", "ッヴァ")
   ,("vve", "ッヴェ")
   ,("vvi", "ッヴィ")
   ,("vvo", "ッヴォ")
   ,("vvu", "ッヴ")
   ,("xtu", "ッ")
   ,("xwa", "ヮ")
   ,("xya", "ャ")
   ,("xyo", "ョ")
   ,("xyu", "ュ")
   ,("yya", "ッヤ")
   ,("yyo", "ッヨ")
   ,("yyu", "ッユ")
   ,("zya", "ジャ")
   ,("zye", "ジェ")
   ,("zyo", "ジョ")
   ,("zyu", "ジュ")
   ,("zza", "ッザ")
   ,("zze", "ッゼ")
   ,("zzi", "ッジ")
   ,("zzo", "ッゾ")
   ,("zzu", "ッズ")
   ,("ba", "バ")
   ,("be", "ベ")
   ,("bi", "ビ")
   ,("bo", "ボ")
   ,("bu", "ブ")
   ,("da", "ダ")
   ,("de", "デ")
   ,("di", "ヂ")
   ,("do", "ド")
   ,("du", "ヅ")
   ,("fa", "ファ")
   ,("fe", "フェ")
   ,("fi", "フィ")
   ,("fo", "フォ")
   ,("fu", "フ")
   ,("ga", "ガ")
   ,("ge", "ゲ")
   ,("gi", "ギ")
   ,("go", "ゴ")
   ,("gu", "グ")
   ,("ha", "ハ")
   ,("he", "ヘ")
   ,("hi", "ヒ")
   ,("ho", "ホ")
   ,("hu", "フ")
   ,("ja", "ジャ")
   ,("je", "ジェ")
   ,("ji", "ジ")
   ,("jo", "ジョ")
   ,("ju", "ジュ")
   ,("ka", "カ")
   ,("ke", "ケ")
   ,("ki", "キ")
   ,("ko", "コ")
   ,("ku", "ク")
   ,("ma", "マ")
   ,("me", "メ")
   ,("mi", "ミ")
   ,("mo", "モ")
   ,("mu", "ム")
   ,("n'", "ン")
   ,("na", "ナ")
   ,("ne", "ネ")
   ,("ni", "ニ")
   ,("no", "ノ")
   ,("nu", "ヌ")
   ,("pa", "パ")
   ,("pe", "ペ")
   ,("pi", "ピ")
   ,("po", "ポ")
   ,("pu", "プ")
   ,("ra", "ラ")
   ,("re", "レ")
   ,("ri", "リ")
   ,("ro", "ロ")
   ,("ru", "ル")
   ,("sa", "サ")
   ,("se", "セ")
   ,("si", "シ")
   ,("so", "ソ")
   ,("su", "ス")
   ,("ta", "タ")
   ,("te", "テ")
   ,("ti", "チ")
   ,("to", "ト")
   ,("tu", "ツ")
   ,("va", "ヴァ")
   ,("ve", "ヴェ")
   ,("vi", "ヴィ")
   ,("vo", "ヴォ")
   ,("vu", "ヴ")
   ,("wa", "ワ")
   ,("we", "ウェ")
   ,("wi", "ウィ")
   ,("wo", "ヲ")
   ,("xa", "ァ")
   ,("xe", "ェ")
   ,("xi", "ィ")
   ,("xo", "ォ")
   ,("xu", "ゥ")
   ,("ya", "ヤ")
   ,("yo", "ヨ")
   ,("yu", "ユ")
   ,("za", "ザ")
   ,("ze", "ゼ")
   ,("zi", "ジ")
   ,("zo", "ゾ")
   ,("zu", "ズ")
   ,("-", "ー")
   ,("a", "ア")
   ,("e", "エ")
   ,("i", "イ")
   ,("n", "ン")
   ,("o", "オ")
   ,("u", "ウ")
   ]

romKanAList_H :: [(Text, Text)]
romKanAList_H =
  [
    ("bbya", "っびゃ")
   ,("bbyo", "っびょ")
   ,("bbyu", "っびゅ")
   ,("ccha", "っちゃ")
   ,("cche", "っちぇ")
   ,("cchi", "っち")
   ,("ccho", "っちょ")
   ,("cchu", "っちゅ")
   ,("ddya", "っぢゃ")
   ,("ddyo", "っぢょ")
   ,("ddyu", "っぢゅ")
   ,("ggya", "っぎゃ")
   ,("ggyo", "っぎょ")
   ,("ggyu", "っぎゅ")
   ,("hhya", "っひゃ")
   ,("hhyo", "っひょ")
   ,("hhyu", "っひゅ")
   ,("kkya", "っきゃ")
   ,("kkyo", "っきょ")
   ,("kkyu", "っきゅ")
   ,("ppya", "っぴゃ")
   ,("ppyo", "っぴょ")
   ,("ppyu", "っぴゅ")
   ,("rrya", "っりゃ")
   ,("rryo", "っりょ")
   ,("rryu", "っりゅ")
   ,("ssha", "っしゃ")
   ,("sshi", "っし")
   ,("ssho", "っしょ")
   ,("sshu", "っしゅ")
   ,("ssya", "っしゃ")
   ,("ssyo", "っしょ")
   ,("ssyu", "っしゅ")
   ,("ttsu", "っつ")
   ,("ttya", "っちゃ")
   ,("ttye", "っちぇ")
   ,("ttyo", "っちょ")
   ,("ttyu", "っちゅ")
   ,("xtsu", "っ")
   ,("zzya", "っじゃ")
   ,("zzyo", "っじょ")
   ,("zzyu", "っじゅ")
   ,("bba", "っば")
   ,("bbe", "っべ")
   ,("bbi", "っび")
   ,("bbo", "っぼ")
   ,("bbu", "っぶ")
   ,("bya", "びゃ")
   ,("byo", "びょ")
   ,("byu", "びゅ")
   ,("cha", "ちゃ")
   ,("che", "ちぇ")
   ,("chi", "ち")
   ,("cho", "ちょ")
   ,("chu", "ちゅ")
   ,("dda", "っだ")
   ,("dde", "っで")
   ,("ddi", "っぢ")
   ,("ddo", "っど")
   ,("ddu", "っづ")
   ,("dya", "ぢゃ")
   ,("dyi", "でぃ")
   ,("dyo", "ぢょ")
   ,("dyu", "ぢゅ")
   ,("ffa", "っふぁ")
   ,("ffe", "っふぇ")
   ,("ffi", "っふぃ")
   ,("ffo", "っふぉ")
   ,("ffu", "っふ")
   ,("gga", "っが")
   ,("gge", "っげ")
   ,("ggi", "っぎ")
   ,("ggo", "っご")
   ,("ggu", "っぐ")
   ,("gya", "ぎゃ")
   ,("gyo", "ぎょ")
   ,("gyu", "ぎゅ")
   ,("hha", "っは")
   ,("hhe", "っへ")
   ,("hhi", "っひ")
   ,("hho", "っほ")
   ,("hhu", "っふ")
   ,("hya", "ひゃ")
   ,("hyo", "ひょ")
   ,("hyu", "ひゅ")
   ,("jja", "っじゃ")
   ,("jji", "っじ")
   ,("jjo", "っじょ")
   ,("jju", "っじゅ")
   ,("kka", "っか")
   ,("kke", "っけ")
   ,("kki", "っき")
   ,("kko", "っこ")
   ,("kku", "っく")
   ,("kya", "きゃ")
   ,("kyo", "きょ")
   ,("kyu", "きゅ")
   ,("mya", "みゃ")
   ,("myo", "みょ")
   ,("myu", "みゅ")
   ,("nya", "にゃ")
   ,("nyo", "にょ")
   ,("nyu", "にゅ")
   ,("ppa", "っぱ")
   ,("ppe", "っぺ")
   ,("ppi", "っぴ")
   ,("ppo", "っぽ")
   ,("ppu", "っぷ")
   ,("pya", "ぴゃ")
   ,("pyo", "ぴょ")
   ,("pyu", "ぴゅ")
   ,("rra", "っら")
   ,("rre", "っれ")
   ,("rri", "っり")
   ,("rro", "っろ")
   ,("rru", "っる")
   ,("rya", "りゃ")
   ,("ryo", "りょ")
   ,("ryu", "りゅ")
   ,("sha", "しゃ")
   ,("shi", "し")
   ,("sho", "しょ")
   ,("shu", "しゅ")
   ,("ssa", "っさ")
   ,("sse", "っせ")
   ,("ssi", "っし")
   ,("sso", "っそ")
   ,("ssu", "っす")
   ,("sya", "しゃ")
   ,("syo", "しょ")
   ,("syu", "しゅ")
   ,("tsu", "つ")
   ,("tta", "った")
   ,("tte", "って")
   ,("tti", "っち")
   ,("tto", "っと")
   ,("ttu", "っつ")
   ,("tya", "ちゃ")
   ,("tye", "ちぇ")
   ,("tyo", "ちょ")
   ,("tyu", "ちゅ")
   ,("vva", "っう゛ぁ")
   ,("vve", "っう゛ぇ")
   ,("vvi", "っう゛ぃ")
   ,("vvo", "っう゛ぉ")
   ,("vvu", "っう゛")
   ,("xtu", "っ")
   ,("xwa", "ゎ")
   ,("xya", "ゃ")
   ,("xyo", "ょ")
   ,("xyu", "ゅ")
   ,("yya", "っや")
   ,("yyo", "っよ")
   ,("yyu", "っゆ")
   ,("zya", "じゃ")
   ,("zye", "じぇ")
   ,("zyo", "じょ")
   ,("zyu", "じゅ")
   ,("zza", "っざ")
   ,("zze", "っぜ")
   ,("zzi", "っじ")
   ,("zzo", "っぞ")
   ,("zzu", "っず")
   ,("ba", "ば")
   ,("be", "べ")
   ,("bi", "び")
   ,("bo", "ぼ")
   ,("bu", "ぶ")
   ,("da", "だ")
   ,("de", "で")
   ,("di", "ぢ")
   ,("do", "ど")
   ,("du", "づ")
   ,("fa", "ふぁ")
   ,("fe", "ふぇ")
   ,("fi", "ふぃ")
   ,("fo", "ふぉ")
   ,("fu", "ふ")
   ,("ga", "が")
   ,("ge", "げ")
   ,("gi", "ぎ")
   ,("go", "ご")
   ,("gu", "ぐ")
   ,("ha", "は")
   ,("he", "へ")
   ,("hi", "ひ")
   ,("ho", "ほ")
   ,("hu", "ふ")
   ,("ja", "じゃ")
   ,("je", "じぇ")
   ,("ji", "じ")
   ,("jo", "じょ")
   ,("ju", "じゅ")
   ,("ka", "か")
   ,("ke", "け")
   ,("ki", "き")
   ,("ko", "こ")
   ,("ku", "く")
   ,("ma", "ま")
   ,("me", "め")
   ,("mi", "み")
   ,("mo", "も")
   ,("mu", "む")
   ,("n'", "ん")
   ,("na", "な")
   ,("ne", "ね")
   ,("ni", "に")
   ,("no", "の")
   ,("nu", "ぬ")
   ,("pa", "ぱ")
   ,("pe", "ぺ")
   ,("pi", "ぴ")
   ,("po", "ぽ")
   ,("pu", "ぷ")
   ,("ra", "ら")
   ,("re", "れ")
   ,("ri", "り")
   ,("ro", "ろ")
   ,("ru", "る")
   ,("sa", "さ")
   ,("se", "せ")
   ,("si", "し")
   ,("so", "そ")
   ,("su", "す")
   ,("ta", "た")
   ,("te", "て")
   ,("ti", "ち")
   ,("to", "と")
   ,("tu", "つ")
   ,("va", "う゛ぁ")
   ,("ve", "う゛ぇ")
   ,("vi", "う゛ぃ")
   ,("vo", "う゛ぉ")
   ,("vu", "う゛")
   ,("wa", "わ")
   ,("we", "うぇ")
   ,("wi", "うぃ")
   ,("wo", "を")
   ,("xa", "ぁ")
   ,("xe", "ぇ")
   ,("xi", "ぃ")
   ,("xo", "ぉ")
   ,("xu", "ぅ")
   ,("ya", "や")
   ,("yo", "よ")
   ,("yu", "ゆ")
   ,("za", "ざ")
   ,("ze", "ぜ")
   ,("zi", "じ")
   ,("zo", "ぞ")
   ,("zu", "ず")
   ,("-", "ー")
   ,("a", "あ")
   ,("e", "え")
   ,("i", "い")
   ,("n", "ん")
   ,("o", "お")
   ,("u", "う")
   ]

kanRomAList :: [(Text, Text)]
kanRomAList =
  [
    ("ッジャ", "jja")
   ,("ッジュ", "jju")
   ,("ッジョ", "jjo")
   ,("ッティ", "tti")
   ,("ッドゥ", "ddu")
   ,("ッファ", "ffa")
   ,("ッフィ", "ffi")
   ,("ッフェ", "ffe")
   ,("ッフォ", "ffo")
   ,("ッフュ", "ffu")
   ,("ッヴァ", "vva")
   ,("ッヴィ", "vvi")
   ,("ッヴェ", "vve")
   ,("ッヴォ", "vvo")
   ,("ッキャ", "kkya")
   ,("ッキュ", "kkyu")
   ,("ッキョ", "kkyo")
   ,("ッギャ", "ggya")
   ,("ッギュ", "ggyu")
   ,("ッギョ", "ggyo")
   ,("ッシェ", "sshe")
   ,("ッシャ", "ssha")
   ,("ッシュ", "sshu")
   ,("ッショ", "ssho")
   ,("ッチェ", "cche")
   ,("ッチャ", "ccha")
   ,("ッチュ", "cchu")
   ,("ッチョ", "ccho")
   ,("ッヂャ", "ddya")
   ,("ッヂュ", "ddyu")
   ,("ッヂョ", "ddyo")
   ,("ッヒャ", "hhya")
   ,("ッヒュ", "hhyu")
   ,("ッヒョ", "hhyo")
   ,("ッビャ", "bbya")
   ,("ッビュ", "bbyu")
   ,("ッビョ", "bbyo")
   ,("ッピャ", "ppya")
   ,("ッピュ", "ppyu")
   ,("ッピョ", "ppyo")
   ,("ッリャ", "rrya")
   ,("ッリュ", "rryu")
   ,("ッリョ", "rryo")
   ,("ウィ", "wi")
   ,("ウェ", "we")
   ,("ウォ", "wo")
   ,("ジェ", "je")
   ,("ジャ", "ja")
   ,("ジュ", "ju")
   ,("ジョ", "jo")
   ,("ティ", "ti")
   ,("ディ", "di")
   ,("ドゥ", "du")
   ,("ファ", "fa")
   ,("フィ", "fi")
   ,("フェ", "fe")
   ,("フォ", "fo")
   ,("フュ", "fu")
   ,("ヴァ", "va")
   ,("ヴィ", "vi")
   ,("ヴェ", "ve")
   ,("ヴォ", "vo")
   ,("キャ", "kya")
   ,("キュ", "kyu")
   ,("キョ", "kyo")
   ,("ギャ", "gya")
   ,("ギュ", "gyu")
   ,("ギョ", "gyo")
   ,("シェ", "she")
   ,("シャ", "sha")
   ,("シュ", "shu")
   ,("ショ", "sho")
   ,("チェ", "che")
   ,("チャ", "cha")
   ,("チュ", "chu")
   ,("チョ", "cho")
   ,("ヂャ", "dya")
   ,("ヂュ", "dyu")
   ,("ヂョ", "dyo")
   ,("ッカ", "kka")
   ,("ッガ", "gga")
   ,("ッキ", "kki")
   ,("ッギ", "ggi")
   ,("ック", "kku")
   ,("ッグ", "ggu")
   ,("ッケ", "kke")
   ,("ッゲ", "gge")
   ,("ッコ", "kko")
   ,("ッゴ", "ggo")
   ,("ッサ", "ssa")
   ,("ッザ", "zza")
   ,("ッジ", "jji")
   ,("ッス", "ssu")
   ,("ッズ", "zzu")
   ,("ッセ", "sse")
   ,("ッゼ", "zze")
   ,("ッソ", "sso")
   ,("ッゾ", "zzo")
   ,("ッタ", "tta")
   ,("ッダ", "dda")
   ,("ッヂ", "ddi")
   ,("ッヅ", "ddu")
   ,("ッテ", "tte")
   ,("ッデ", "dde")
   ,("ット", "tto")
   ,("ッド", "ddo")
   ,("ッハ", "hha")
   ,("ッバ", "bba")
   ,("ッパ", "ppa")
   ,("ッヒ", "hhi")
   ,("ッビ", "bbi")
   ,("ッピ", "ppi")
   ,("ッフ", "ffu")
   ,("ッブ", "bbu")
   ,("ップ", "ppu")
   ,("ッヘ", "hhe")
   ,("ッベ", "bbe")
   ,("ッペ", "ppe")
   ,("ッホ", "hho")
   ,("ッボ", "bbo")
   ,("ッポ", "ppo")
   ,("ッヤ", "yya")
   ,("ッユ", "yyu")
   ,("ッヨ", "yyo")
   ,("ッラ", "rra")
   ,("ッリ", "rri")
   ,("ッル", "rru")
   ,("ッレ", "rre")
   ,("ッロ", "rro")
   ,("ッヴ", "vvu")
   ,("ニャ", "nya")
   ,("ニュ", "nyu")
   ,("ニョ", "nyo")
   ,("ヒャ", "hya")
   ,("ヒュ", "hyu")
   ,("ヒョ", "hyo")
   ,("ビャ", "bya")
   ,("ビュ", "byu")
   ,("ビョ", "byo")
   ,("ピャ", "pya")
   ,("ピュ", "pyu")
   ,("ピョ", "pyo")
   ,("ミャ", "mya")
   ,("ミュ", "myu")
   ,("ミョ", "myo")
   ,("リャ", "rya")
   ,("リュ", "ryu")
   ,("リョ", "ryo")
   ,("ッシ", "sshi")
   ,("ッチ", "cchi")
   ,("ッツ", "ttsu")
   ,("ア", "a")
   ,("イ", "i")
   ,("ウ", "u")
   ,("エ", "e")
   ,("オ", "o")
   ,("ー", "-")
   ,("ァ", "xa")
   ,("ィ", "xi")
   ,("ゥ", "xu")
   ,("ェ", "xe")
   ,("ォ", "xo")
   ,("カ", "ka")
   ,("ガ", "ga")
   ,("キ", "ki")
   ,("ギ", "gi")
   ,("ク", "ku")
   ,("グ", "gu")
   ,("ケ", "ke")
   ,("ゲ", "ge")
   ,("コ", "ko")
   ,("ゴ", "go")
   ,("サ", "sa")
   ,("ザ", "za")
   ,("ジ", "ji")
   ,("ス", "su")
   ,("ズ", "zu")
   ,("セ", "se")
   ,("ゼ", "ze")
   ,("ソ", "so")
   ,("ゾ", "zo")
   ,("タ", "ta")
   ,("ダ", "da")
   ,("ヂ", "di")
   ,("ヅ", "du")
   ,("テ", "te")
   ,("デ", "de")
   ,("ト", "to")
   ,("ド", "do")
   ,("ナ", "na")
   ,("ニ", "ni")
   ,("ヌ", "nu")
   ,("ネ", "ne")
   ,("ノ", "no")
   ,("ハ", "ha")
   ,("バ", "ba")
   ,("パ", "pa")
   ,("ヒ", "hi")
   ,("ビ", "bi")
   ,("ピ", "pi")
   ,("フ", "fu")
   ,("ブ", "bu")
   ,("プ", "pu")
   ,("ヘ", "he")
   ,("ベ", "be")
   ,("ペ", "pe")
   ,("ホ", "ho")
   ,("ボ", "bo")
   ,("ポ", "po")
   ,("マ", "ma")
   ,("ミ", "mi")
   ,("ム", "mu")
   ,("メ", "me")
   ,("モ", "mo")
   ,("ヤ", "ya")
   ,("ユ", "yu")
   ,("ヨ", "yo")
   ,("ラ", "ra")
   ,("リ", "ri")
   ,("ル", "ru")
   ,("レ", "re")
   ,("ロ", "ro")
   ,("ワ", "wa")
   ,("ヰ", "wi")
   ,("ヱ", "we")
   ,("ヲ", "wo")
   ,("ン", "n'")
   ,("ヴ", "vu")
   ,("シ", "shi")
   ,("チ", "chi")
   ,("ツ", "tsu")
   ,("ャ", "xya")
   ,("ュ", "xyu")
   ,("ョ", "xyo")
   ,("ヮ", "xwa")
   ,("ッ", "xtsu")
   ]

kanRomAList_H :: [(Text, Text)]
kanRomAList_H =
  [
    ("っう゛ぁ", "vva")
   ,("っう゛ぃ", "vvi")
   ,("っう゛ぇ", "vve")
   ,("っう゛ぉ", "vvo")
   ,("う゛ぁ", "va")
   ,("う゛ぃ", "vi")
   ,("う゛ぇ", "ve")
   ,("う゛ぉ", "vo")
   ,("っう゛", "vvu")
   ,("っじゃ", "jja")
   ,("っじゅ", "jju")
   ,("っじょ", "jjo")
   ,("っふぁ", "ffa")
   ,("っふぃ", "ffi")
   ,("っふぇ", "ffe")
   ,("っふぉ", "ffo")
   ,("っきゃ", "kkya")
   ,("っきゅ", "kkyu")
   ,("っきょ", "kkyo")
   ,("っぎゃ", "ggya")
   ,("っぎゅ", "ggyu")
   ,("っぎょ", "ggyo")
   ,("っしゃ", "ssha")
   ,("っしゅ", "sshu")
   ,("っしょ", "ssho")
   ,("っちぇ", "cche")
   ,("っちゃ", "ccha")
   ,("っちゅ", "cchu")
   ,("っちょ", "ccho")
   ,("っぢゃ", "ddya")
   ,("っぢゅ", "ddyu")
   ,("っぢょ", "ddyo")
   ,("っひゃ", "hhya")
   ,("っひゅ", "hhyu")
   ,("っひょ", "hhyo")
   ,("っびゃ", "bbya")
   ,("っびゅ", "bbyu")
   ,("っびょ", "bbyo")
   ,("っぴゃ", "ppya")
   ,("っぴゅ", "ppyu")
   ,("っぴょ", "ppyo")
   ,("っりゃ", "rrya")
   ,("っりゅ", "rryu")
   ,("っりょ", "rryo")
   ,("う゛", "vu")
   ,("じぇ", "je")
   ,("じゃ", "ja")
   ,("じゅ", "ju")
   ,("じょ", "jo")
   ,("ふぁ", "fa")
   ,("ふぃ", "fi")
   ,("ふぇ", "fe")
   ,("ふぉ", "fo")
   ,("きゃ", "kya")
   ,("きゅ", "kyu")
   ,("きょ", "kyo")
   ,("ぎゃ", "gya")
   ,("ぎゅ", "gyu")
   ,("ぎょ", "gyo")
   ,("しゃ", "sha")
   ,("しゅ", "shu")
   ,("しょ", "sho")
   ,("ちぇ", "che")
   ,("ちゃ", "cha")
   ,("ちゅ", "chu")
   ,("ちょ", "cho")
   ,("ぢゃ", "dya")
   ,("ぢゅ", "dyu")
   ,("ぢょ", "dyo")
   ,("っか", "kka")
   ,("っが", "gga")
   ,("っき", "kki")
   ,("っぎ", "ggi")
   ,("っく", "kku")
   ,("っぐ", "ggu")
   ,("っけ", "kke")
   ,("っげ", "gge")
   ,("っこ", "kko")
   ,("っご", "ggo")
   ,("っさ", "ssa")
   ,("っざ", "zza")
   ,("っじ", "jji")
   ,("っす", "ssu")
   ,("っず", "zzu")
   ,("っせ", "sse")
   ,("っぜ", "zze")
   ,("っそ", "sso")
   ,("っぞ", "zzo")
   ,("った", "tta")
   ,("っだ", "dda")
   ,("っぢ", "ddi")
   ,("っづ", "ddu")
   ,("って", "tte")
   ,("っで", "dde")
   ,("っと", "tto")
   ,("っど", "ddo")
   ,("っは", "hha")
   ,("っば", "bba")
   ,("っぱ", "ppa")
   ,("っひ", "hhi")
   ,("っび", "bbi")
   ,("っぴ", "ppi")
   ,("っふ", "ffu")
   ,("っぶ", "bbu")
   ,("っぷ", "ppu")
   ,("っへ", "hhe")
   ,("っべ", "bbe")
   ,("っぺ", "ppe")
   ,("っほ", "hho")
   ,("っぼ", "bbo")
   ,("っぽ", "ppo")
   ,("っや", "yya")
   ,("っゆ", "yyu")
   ,("っよ", "yyo")
   ,("っら", "rra")
   ,("っり", "rri")
   ,("っる", "rru")
   ,("っれ", "rre")
   ,("っろ", "rro")
   ,("でぃ", "dyi")
   ,("にゃ", "nya")
   ,("にゅ", "nyu")
   ,("にょ", "nyo")
   ,("ひゃ", "hya")
   ,("ひゅ", "hyu")
   ,("ひょ", "hyo")
   ,("びゃ", "bya")
   ,("びゅ", "byu")
   ,("びょ", "byo")
   ,("ぴゃ", "pya")
   ,("ぴゅ", "pyu")
   ,("ぴょ", "pyo")
   ,("みゃ", "mya")
   ,("みゅ", "myu")
   ,("みょ", "myo")
   ,("りゃ", "rya")
   ,("りゅ", "ryu")
   ,("りょ", "ryo")
   ,("っし", "sshi")
   ,("っち", "cchi")
   ,("っつ", "ttsu")
   ,("あ", "a")
   ,("い", "i")
   ,("う", "u")
   ,("え", "e")
   ,("お", "o")
   ,("ー", "-")
   ,("ぁ", "xa")
   ,("ぃ", "xi")
   ,("ぅ", "xu")
   ,("ぇ", "xe")
   ,("ぉ", "xo")
   ,("か", "ka")
   ,("が", "ga")
   ,("き", "ki")
   ,("ぎ", "gi")
   ,("く", "ku")
   ,("ぐ", "gu")
   ,("け", "ke")
   ,("げ", "ge")
   ,("こ", "ko")
   ,("ご", "go")
   ,("さ", "sa")
   ,("ざ", "za")
   ,("じ", "ji")
   ,("す", "su")
   ,("ず", "zu")
   ,("せ", "se")
   ,("ぜ", "ze")
   ,("そ", "so")
   ,("ぞ", "zo")
   ,("た", "ta")
   ,("だ", "da")
   ,("ぢ", "di")
   ,("づ", "du")
   ,("て", "te")
   ,("で", "de")
   ,("と", "to")
   ,("ど", "do")
   ,("な", "na")
   ,("に", "ni")
   ,("ぬ", "nu")
   ,("ね", "ne")
   ,("の", "no")
   ,("は", "ha")
   ,("ば", "ba")
   ,("ぱ", "pa")
   ,("ひ", "hi")
   ,("び", "bi")
   ,("ぴ", "pi")
   ,("ふ", "fu")
   ,("ぶ", "bu")
   ,("ぷ", "pu")
   ,("へ", "he")
   ,("べ", "be")
   ,("ぺ", "pe")
   ,("ほ", "ho")
   ,("ぼ", "bo")
   ,("ぽ", "po")
   ,("ま", "ma")
   ,("み", "mi")
   ,("む", "mu")
   ,("め", "me")
   ,("も", "mo")
   ,("や", "ya")
   ,("ゆ", "yu")
   ,("よ", "yo")
   ,("ら", "ra")
   ,("り", "ri")
   ,("る", "ru")
   ,("れ", "re")
   ,("ろ", "ro")
   ,("わ", "wa")
   ,("ゐ", "wi")
   ,("ゑ", "we")
   ,("を", "wo")
   ,("ん", "n'")
   ,("し", "shi")
   ,("ち", "chi")
   ,("つ", "tsu")
   ,("ゃ", "xya")
   ,("ゅ", "xyu")
   ,("ょ", "xyo")
   ,("ゎ", "xwa")
   ,("っ", "xtsu")
   ]

kunreiToHepburnAList :: [(Text, Text)]
kunreiToHepburnAList =
  [
    ("bbya", "bbya")
   ,("bbyo", "bbyo")
   ,("bbyu", "bbyu")
   ,("ddya", "ddya")
   ,("ddyo", "ddyo")
   ,("ddyu", "ddyu")
   ,("ggya", "ggya")
   ,("ggyo", "ggyo")
   ,("ggyu", "ggyu")
   ,("hhya", "hhya")
   ,("hhyo", "hhyo")
   ,("hhyu", "hhyu")
   ,("kkya", "kkya")
   ,("kkyo", "kkyo")
   ,("kkyu", "kkyu")
   ,("ppya", "ppya")
   ,("ppyo", "ppyo")
   ,("ppyu", "ppyu")
   ,("rrya", "rrya")
   ,("rryo", "rryo")
   ,("rryu", "rryu")
   ,("ssya", "ssha")
   ,("ssye", "sshe")
   ,("ssyo", "ssho")
   ,("ssyu", "sshu")
   ,("ttya", "ccha")
   ,("ttye", "cche")
   ,("ttyo", "ccho")
   ,("ttyu", "cchu")
   ,("zzya", "jja")
   ,("zzyo", "jjo")
   ,("zzyu", "jju")
   ,("bba", "bba")
   ,("bbe", "bbe")
   ,("bbi", "bbi")
   ,("bbo", "bbo")
   ,("bbu", "bbu")
   ,("bya", "bya")
   ,("byo", "byo")
   ,("byu", "byu")
   ,("dda", "dda")
   ,("dde", "dde")
   ,("ddi", "ddi")
   ,("ddo", "ddo")
   ,("ddu", "ddu")
   ,("dya", "dya")
   ,("dyi", "di")
   ,("dyo", "dyo")
   ,("dyu", "dyu")
   ,("ffa", "ffa")
   ,("ffe", "ffe")
   ,("ffi", "ffi")
   ,("ffo", "ffo")
   ,("ffu", "ffu")
   ,("gga", "gga")
   ,("gge", "gge")
   ,("ggi", "ggi")
   ,("ggo", "ggo")
   ,("ggu", "ggu")
   ,("gya", "gya")
   ,("gyo", "gyo")
   ,("gyu", "gyu")
   ,("hha", "hha")
   ,("hhe", "hhe")
   ,("hhi", "hhi")
   ,("hho", "hho")
   ,("hhu", "ffu")
   ,("hya", "hya")
   ,("hyo", "hyo")
   ,("hyu", "hyu")
   ,("kka", "kka")
   ,("kke", "kke")
   ,("kki", "kki")
   ,("kko", "kko")
   ,("kku", "kku")
   ,("kya", "kya")
   ,("kyo", "kyo")
   ,("kyu", "kyu")
   ,("mya", "mya")
   ,("myo", "myo")
   ,("myu", "myu")
   ,("nya", "nya")
   ,("nyo", "nyo")
   ,("nyu", "nyu")
   ,("ppa", "ppa")
   ,("ppe", "ppe")
   ,("ppi", "ppi")
   ,("ppo", "ppo")
   ,("ppu", "ppu")
   ,("pya", "pya")
   ,("pyo", "pyo")
   ,("pyu", "pyu")
   ,("rra", "rra")
   ,("rre", "rre")
   ,("rri", "rri")
   ,("rro", "rro")
   ,("rru", "rru")
   ,("rya", "rya")
   ,("ryo", "ryo")
   ,("ryu", "ryu")
   ,("ssa", "ssa")
   ,("sse", "sse")
   ,("ssi", "sshi")
   ,("sso", "sso")
   ,("ssu", "ssu")
   ,("sya", "sha")
   ,("sye", "she")
   ,("syo", "sho")
   ,("syu", "shu")
   ,("tta", "tta")
   ,("tte", "tte")
   ,("tti", "tti")
   ,("tto", "tto")
   ,("ttu", "ttsu")
   ,("tya", "cha")
   ,("tye", "che")
   ,("tyo", "cho")
   ,("tyu", "chu")
   ,("vva", "vva")
   ,("vve", "vve")
   ,("vvi", "vvi")
   ,("vvo", "vvo")
   ,("vvu", "vvu")
   ,("xtu", "xtsu")
   ,("xwa", "xwa")
   ,("xya", "xya")
   ,("xyo", "xyo")
   ,("xyu", "xyu")
   ,("yya", "yya")
   ,("yyo", "yyo")
   ,("yyu", "yyu")
   ,("zya", "ja")
   ,("zye", "je")
   ,("zyo", "jo")
   ,("zyu", "ju")
   ,("zza", "zza")
   ,("zze", "zze")
   ,("zzi", "jji")
   ,("zzo", "zzo")
   ,("zzu", "zzu")
   ,("ba", "ba")
   ,("be", "be")
   ,("bi", "bi")
   ,("bo", "bo")
   ,("bu", "bu")
   ,("da", "da")
   ,("de", "de")
   ,("di", "di")
   ,("do", "do")
   ,("du", "du")
   ,("fa", "fa")
   ,("fe", "fe")
   ,("fi", "fi")
   ,("fo", "fo")
   ,("fu", "fu")
   ,("ga", "ga")
   ,("ge", "ge")
   ,("gi", "gi")
   ,("go", "go")
   ,("gu", "gu")
   ,("ha", "ha")
   ,("he", "he")
   ,("hi", "hi")
   ,("ho", "ho")
   ,("hu", "fu")
   ,("ka", "ka")
   ,("ke", "ke")
   ,("ki", "ki")
   ,("ko", "ko")
   ,("ku", "ku")
   ,("ma", "ma")
   ,("me", "me")
   ,("mi", "mi")
   ,("mo", "mo")
   ,("mu", "mu")
   ,("n'", "n'")
   ,("na", "na")
   ,("ne", "ne")
   ,("ni", "ni")
   ,("no", "no")
   ,("nu", "nu")
   ,("pa", "pa")
   ,("pe", "pe")
   ,("pi", "pi")
   ,("po", "po")
   ,("pu", "pu")
   ,("ra", "ra")
   ,("re", "re")
   ,("ri", "ri")
   ,("ro", "ro")
   ,("ru", "ru")
   ,("sa", "sa")
   ,("se", "se")
   ,("si", "shi")
   ,("so", "so")
   ,("su", "su")
   ,("ta", "ta")
   ,("te", "te")
   ,("ti", "chi")
   ,("to", "to")
   ,("tu", "tsu")
   ,("va", "va")
   ,("ve", "ve")
   ,("vi", "vi")
   ,("vo", "vo")
   ,("vu", "vu")
   ,("wa", "wa")
   ,("we", "we")
   ,("wi", "wi")
   ,("wo", "wo")
   ,("xa", "xa")
   ,("xe", "xe")
   ,("xi", "xi")
   ,("xo", "xo")
   ,("xu", "xu")
   ,("ya", "ya")
   ,("yo", "yo")
   ,("yu", "yu")
   ,("za", "za")
   ,("ze", "ze")
   ,("zi", "ji")
   ,("zo", "zo")
   ,("zu", "zu")
   ,("-", "-")
   ,("a", "a")
   ,("e", "e")
   ,("i", "i")
   ,("n", "n")
   ,("o", "o")
   ,("u", "u")
   ]

hepburnToKunreiAList :: [(Text, Text)]
hepburnToKunreiAList =
  [
    ("bbya", "bbya")
   ,("bbyo", "bbyo")
   ,("bbyu", "bbyu")
   ,("ccha", "ttya")
   ,("cche", "ttye")
   ,("cchi", "tti")
   ,("ccho", "ttyo")
   ,("cchu", "ttyu")
   ,("ddya", "ddya")
   ,("ddyo", "ddyo")
   ,("ddyu", "ddyu")
   ,("ggya", "ggya")
   ,("ggyo", "ggyo")
   ,("ggyu", "ggyu")
   ,("hhya", "hhya")
   ,("hhyo", "hhyo")
   ,("hhyu", "hhyu")
   ,("kkya", "kkya")
   ,("kkyo", "kkyo")
   ,("kkyu", "kkyu")
   ,("ppya", "ppya")
   ,("ppyo", "ppyo")
   ,("ppyu", "ppyu")
   ,("rrya", "rrya")
   ,("rryo", "rryo")
   ,("rryu", "rryu")
   ,("ssha", "ssya")
   ,("sshe", "ssye")
   ,("sshi", "ssi")
   ,("ssho", "ssyo")
   ,("sshu", "ssyu")
   ,("ttsu", "ttu")
   ,("xtsu", "xtu")
   ,("bba", "bba")
   ,("bbe", "bbe")
   ,("bbi", "bbi")
   ,("bbo", "bbo")
   ,("bbu", "bbu")
   ,("bya", "bya")
   ,("byo", "byo")
   ,("byu", "byu")
   ,("cha", "tya")
   ,("che", "tye")
   ,("chi", "ti")
   ,("cho", "tyo")
   ,("chu", "tyu")
   ,("dda", "dda")
   ,("dde", "dde")
   ,("ddi", "ddi")
   ,("ddo", "ddo")
   ,("ddu", "ddu")
   ,("dya", "dya")
   ,("dyo", "dyo")
   ,("dyu", "dyu")
   ,("ffa", "ffa")
   ,("ffe", "ffe")
   ,("ffi", "ffi")
   ,("ffo", "ffo")
   ,("ffu", "ffu")
   ,("gga", "gga")
   ,("gge", "gge")
   ,("ggi", "ggi")
   ,("ggo", "ggo")
   ,("ggu", "ggu")
   ,("gya", "gya")
   ,("gyo", "gyo")
   ,("gyu", "gyu")
   ,("hha", "hha")
   ,("hhe", "hhe")
   ,("hhi", "hhi")
   ,("hho", "hho")
   ,("hya", "hya")
   ,("hyo", "hyo")
   ,("hyu", "hyu")
   ,("jja", "zzya")
   ,("jji", "zzi")
   ,("jjo", "zzyo")
   ,("jju", "zzyu")
   ,("kka", "kka")
   ,("kke", "kke")
   ,("kki", "kki")
   ,("kko", "kko")
   ,("kku", "kku")
   ,("kya", "kya")
   ,("kyo", "kyo")
   ,("kyu", "kyu")
   ,("mya", "mya")
   ,("myo", "myo")
   ,("myu", "myu")
   ,("nya", "nya")
   ,("nyo", "nyo")
   ,("nyu", "nyu")
   ,("ppa", "ppa")
   ,("ppe", "ppe")
   ,("ppi", "ppi")
   ,("ppo", "ppo")
   ,("ppu", "ppu")
   ,("pya", "pya")
   ,("pyo", "pyo")
   ,("pyu", "pyu")
   ,("rra", "rra")
   ,("rre", "rre")
   ,("rri", "rri")
   ,("rro", "rro")
   ,("rru", "rru")
   ,("rya", "rya")
   ,("ryo", "ryo")
   ,("ryu", "ryu")
   ,("sha", "sya")
   ,("she", "sye")
   ,("shi", "si")
   ,("sho", "syo")
   ,("shu", "syu")
   ,("ssa", "ssa")
   ,("sse", "sse")
   ,("sso", "sso")
   ,("ssu", "ssu")
   ,("tsu", "tu")
   ,("tta", "tta")
   ,("tte", "tte")
   ,("tti", "tti")
   ,("tto", "tto")
   ,("vva", "vva")
   ,("vve", "vve")
   ,("vvi", "vvi")
   ,("vvo", "vvo")
   ,("vvu", "vvu")
   ,("xwa", "xwa")
   ,("xya", "xya")
   ,("xyo", "xyo")
   ,("xyu", "xyu")
   ,("yya", "yya")
   ,("yyo", "yyo")
   ,("yyu", "yyu")
   ,("zza", "zza")
   ,("zze", "zze")
   ,("zzo", "zzo")
   ,("zzu", "zzu")
   ,("ba", "ba")
   ,("be", "be")
   ,("bi", "bi")
   ,("bo", "bo")
   ,("bu", "bu")
   ,("da", "da")
   ,("de", "de")
   ,("di", "dyi")
   ,("do", "do")
   ,("du", "du")
   ,("fa", "fa")
   ,("fe", "fe")
   ,("fi", "fi")
   ,("fo", "fo")
   ,("fu", "fu")
   ,("ga", "ga")
   ,("ge", "ge")
   ,("gi", "gi")
   ,("go", "go")
   ,("gu", "gu")
   ,("ha", "ha")
   ,("he", "he")
   ,("hi", "hi")
   ,("ho", "ho")
   ,("ja", "zya")
   ,("je", "zye")
   ,("ji", "zi")
   ,("jo", "zyo")
   ,("ju", "zyu")
   ,("ka", "ka")
   ,("ke", "ke")
   ,("ki", "ki")
   ,("ko", "ko")
   ,("ku", "ku")
   ,("ma", "ma")
   ,("me", "me")
   ,("mi", "mi")
   ,("mo", "mo")
   ,("mu", "mu")
   ,("n'", "n'")
   ,("na", "na")
   ,("ne", "ne")
   ,("ni", "ni")
   ,("no", "no")
   ,("nu", "nu")
   ,("pa", "pa")
   ,("pe", "pe")
   ,("pi", "pi")
   ,("po", "po")
   ,("pu", "pu")
   ,("ra", "ra")
   ,("re", "re")
   ,("ri", "ri")
   ,("ro", "ro")
   ,("ru", "ru")
   ,("sa", "sa")
   ,("se", "se")
   ,("so", "so")
   ,("su", "su")
   ,("ta", "ta")
   ,("te", "te")
   ,("ti", "ti")
   ,("to", "to")
   ,("va", "va")
   ,("ve", "ve")
   ,("vi", "vi")
   ,("vo", "vo")
   ,("vu", "vu")
   ,("wa", "wa")
   ,("we", "we")
   ,("wi", "wi")
   ,("wo", "wo")
   ,("xa", "xa")
   ,("xe", "xe")
   ,("xi", "xi")
   ,("xo", "xo")
   ,("xu", "xu")
   ,("ya", "ya")
   ,("yo", "yo")
   ,("yu", "yu")
   ,("za", "za")
   ,("ze", "ze")
   ,("zo", "zo")
   ,("zu", "zu")
   ,("-", "-")
   ,("a", "a")
   ,("e", "e")
   ,("i", "i")
   ,("n", "n")
   ,("o", "o")
   ,("u", "u")
   ]
